\def\filedate{2018/06/26}
\def\fileversion{1.00-dev}

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{beamerinnerthemeustutt}[\filedate\space Version \fileversion\space by Philipp Tempel <philipp.tempel@isw.uni-stuttgart.de>]


\RequirePackage{etoolbox}
\RequirePackage{keyval}
\RequirePackage{calc}
\RequirePackage{pgfopts}
\RequirePackage{tikz}

% titlepage=standard {default}
% titlepage=bigtext
\pgfkeys{%
  /ustutt/inner/titlepage/.cd,%
    .is choice,%
    standard/.code={%
      \setbeamertemplate{title page}[ustutt standard]%
    },%
    small/.code={%
      \setbeamertemplate{title page}[ustutt standard]%
    },%
    huge/.code={%
      \setbeamertemplate{title page}[ustutt huge]%
    },%
}%
\pgfkeys{%
  /ustutt/inner/sectionpage/.cd,%
    .is choice,%
    none/.code=\ustutt@disablesectionpage,%
    circle/.code={%
      \ustutt@enablesectionpage%
      \setbeamertemplate{section page}[ustutt]%
    },%
}
\pgfkeys{%
  /ustutt/inner/subsectionpage/.cd,%
    .is choice,%
    none/.code=\ustutt@disablesubsectionpage,%
    plain/.code={%
      \ustutt@enablesubsectionpage%
      \setbeamertemplate{subsection page}[ustutt]%
    },%
}
\pgfkeys{%
  /ustutt/inner/toc/.cd,%
    .is choice,%
    simple/.code={%
      \setbeamertemplate{section in toc}[ustutt simple]%
      \setbeamertemplate{subsection in toc}[ustutt simple]%
    },%
    bars/.code={%
      \setbeamertemplate{section in toc}[ustutt bars]%
      \setbeamertemplate{subsection in toc}[ustutt bars]%
    },%
}
\newcommand{\ustutt@inner@setdefaults}{%
  \pgfkeys{/ustutt/inner/.cd,%
    titlepage=standard,%
    toc=simple,%
    sectionpage=none,
    subsectionpage=none,%
  }%
}

\defbeamertemplate*{itemize item}{circles ustutt}{%
  \usebeamerfont*{itemize item}\raise1.25pt\hbox{\donotcoloroutermaths$\bullet$}%
}
\defbeamertemplate*{itemize items}{circles ustutt}{%
  \usebeamerfont*{itemize item}\raise1.25pt\hbox{\donotcoloroutermaths$\bullet$}%
}
\defbeamertemplate*{itemize subitem}{circles ustutt}{%
  \usebeamerfont*{itemize subitem}\raise1.25pt\hbox{\donotcoloroutermaths$\bullet$}%
}
\defbeamertemplate*{itemize subsubitem}{circles ustutt}{%
  \usebeamerfont*{itemize subsubitem}\raise1.25pt\hbox{\donotcoloroutermaths$\bullet$}%
}
\setbeamertemplate{itemize/enumerate body begin}{%
  \setlength{\itemsep}{0.00em}%
  \setlength{\parsep}{0.25em}%
  \setlength{\parskip}{0.25em}%
  \setlength{\leftmargini}{1.00em}%
  \setlength{\leftmarginii}{0.75em}%
  \setlength{\leftmarginiii}{0.65em}%
  \setlength{\leftmarginiv}{0.55em}%
  \setlength{\labelsep}{0.30em}%
}

\defbeamertemplate{title page}{ustutt standard}{%
  \tikzexternaldisable%
  \begin{tikzpicture}[%
      overlay,%
      remember picture,%
    ]
    % Place title graphic if it exists
    \ifx\inserttitlegraphic\@empty\else
      \node[%
          align=center,%
          inner sep=0.00pt,%
          outer sep=0.00pt,%
          % anchor=north,%
        ]%
          (ustutt title graphic)
          at ([shift={(0.00, -0.125\paperheight)}]current page.center)%
          {%
            \inserttitlegraphic%
          };
    \fi
    % White bar at the top
    \draw[%
        fill=palette primary.fg,%
        draw=palette primary.fg,%
      ]%
        (current page.north west)%
          rectangle ([shift={(0.00, -0.25\paperheight)}]current page.north east);
    % Date of presentation
    \ifx\insertdate\@empty\else
      \node[%
          anchor=north east,%
          align=center,%
          inner sep=0.00pt,%
          outer sep=0.00pt,%
        ]%
          at ([shift={(-0.05\paperheight,-0.05\paperheight)}]current page.north east)%
          {
            \usebeamerfont{date}%
            \usebeamercolor{date}%
            \insertdate%
          };
    \fi
    % University logo and department name
    \begin{scope}
      % English language presentation
      \ifcurrentbaselanguage{english}{%
        % University logo
        \node[%
            anchor=north west,%
          ]%
            at ([shift={(0.05\paperheight,-0.05\paperheight)}]current page.north west)%
            {%
              \includegraphics[width=0.25\paperwidth]{images/logo-university-en}%
            };%
        \ifx\insertinstitute\@empty\else
          \node[%
              draw=none,%
              text width=0.50\paperwidth,%
              inner sep=0.50em,%
              outer sep=0.00pt,%
              anchor=north west,%
              align=justify,%
            ]%
              at ([shift={(0.14875\paperheight, -0.145\paperheight)}]current page.north west)%
              {%
                \usebeamertemplate*{institute}%
              };
        \fi
      % Non-English presentation (we assume it's German then)
      }{
        % University logo
        \node[%
            anchor=north west,%
          ]%
            at ([shift={(0.05\paperheight,-0.05\paperheight)}]current page.north west)%
            {%
              \includegraphics[width=0.25\paperwidth]{images/logo-university-de}%
            };%
        \ifx\insertinstitute\@empty\else
          \node[%
              draw=none,%
              text width=0.50\paperwidth,%
              inner sep=0.50em,%
              outer sep=0.00pt,%
              anchor=north west,%
              align=justify,%
            ]%
              at ([shift={(0.15375\paperheight, -0.125\paperheight)}]current page.north west)%
              {%
                \usebeamertemplate*{institute}%
              };
        \fi
      }
    \end{scope}
    % Title and author bubbles
    \begin{scope}
      % Title
      \node[
        circle,%
        text width=0.70\paperheight,%
        inner sep=1.00ex,%
        outer sep=0.00pt,%
        align=left,%
        fill=palette primary.bg,%
        draw=none,%
      ]%
        (title node)%
        at ([shift={(0.25\paperwidth,-0.0375\paperheight)}]current page.center)%
        {%
          \begin{minipage}[t]{0.68\paperheight}%
            \usebeamertemplate*{title}%
            \usebeamertemplate*{subtitle}%
          \end{minipage}%
        };
      % Author
      \node[
        circle,%
        % anchor=south east,%
        text width=0.185\paperheight,%
        inner sep=0.50em,%
        outer sep=0.00pt,%
        align=center,%
        fill=palette primary.fg,%
        draw=none,%
      ]%
        at (title node.315)%
        {%
          \ifx\insertauthor\@empty\else\usebeamertemplate*{author}\fi%
        };
    \end{scope}
  \end{tikzpicture}
}

% UStutt titlepage with a huge bubble for more text
\defbeamertemplate{title page}{ustutt huge}{%
  \tikzexternaldisable%
  \begin{tikzpicture}[%
      overlay,%
      remember picture,%
    ]
    \ifx\inserttitlegraphic\@empty\else
      \begin{scope}
        % Clip titlegraphic
        \clip%
          ([shift={(0.00, -0.25\paperheight)}]current page.north west)
            rectangle (current page.south east);
        % Place title graphic
        \node[%
            % draw=UStuttDarkOne,%
            align=center,%
            inner sep=0.00pt,%
            outer sep=0.00pt,%
          ]%
            at ([shift={(0.00, -0.125\paperheight)}]current page)%
            {%
              \inserttitlegraphic%
            };
      \end{scope}
    \fi
    % Date of presentation
    \ifx\insertdate\@empty\else
      \node[%
          anchor=north east,%
          align=center,%
          inner sep=0.00pt,%
          outer sep=0.00pt,%
        ]%
          at ([shift={(-0.05\paperheight,-0.05\paperheight)}]current page.north east)%
          {
            \usebeamerfont{date}%
            \usebeamercolor{date}%
            \insertdate%
          };
    \fi
    % University logo and department name
    \begin{scope}
      % English language presentation
      \ifcurrentbaselanguage{english}{
        % University logo
        \node[%
            anchor=north west,%
          ]%
            at ([shift={(0.05\paperheight,-0.05\paperheight)}]current page.north west)%
            {%
              \includegraphics[width=0.25\paperwidth]{images/logo-university-en}%
            };%
        \ifx\insertinstitute\@empty\else
          \node[%
              draw=none,%
              text width=0.40\paperwidth,%
              inner sep=0.50em,%
              outer sep=0.00pt,%
              anchor=north west,%
              align=justify,%
            ]%
              at ([shift={(0.145\paperheight, -0.145\paperheight)}]current page.north west)%
              {%
                \usebeamertemplate*{institute}%
              };
        \fi
      % Non-English presentation (we assume it's German then)
      }{
        % University logo
        \node[%
            anchor=north west,%
          ]%
            at ([shift={(0.05\paperheight,-0.05\paperheight)}]current page.north west)%
            {%
              \includegraphics[width=0.25\paperwidth]{images/logo-university-de}%
            };%
        \ifx\insertinstitute\@empty\else
          \node[%
              draw=none,%
              text width=0.40\paperwidth,%
              inner sep=0.50em,%
              outer sep=0.00pt,%
              anchor=north west,%
              align=justify,%
            ]%
              at ([shift={(0.15375\paperheight, -0.1125\paperheight)}]current page.north west)%
              {%
                \usebeamertemplate*{institute}%
              };
        \fi
      }
    \end{scope}
    % Title and author bubbles
    \begin{scope}
      % Title
      \node[
        circle,%
        text width=0.85\paperheight,%
        inner sep=1.00ex,%
        outer sep=0.00pt,%
        align=left,%
        fill=palette primary.bg,%
        draw=none,%
      ]%
        (title node)%
        at ([shift={(0.20\paperwidth,-0.0375\paperheight)}]current page.center)%
        {%
          \begin{minipage}[t]{0.83\paperheight}%
            \ifx\inserttitle\@empty\else\usebeamertemplate*{title}\fi%
            \ifx\insertsubtitle\@empty\else\usebeamertemplate*{subtitle}\fi%
          \end{minipage}%
        };
      % Author
      \node[
        circle,%
        % anchor=south east,%
        text width=0.225\paperheight,%
        inner sep=0.50em,%
        outer sep=0.00pt,%
        align=center,%
        fill=palette primary.fg,%
        draw=none,%
      ]%
        at (title node.225)%
        {%
          \ifx\insertauthor\@empty\else\usebeamertemplate*{author}\fi%
        };
    \end{scope}
  \end{tikzpicture}
}

\def\maketitle{%
  \ifbeamer@inframe
    \titlepage
  \else
    \frame[plain,noframenumbering]{%
      \titlepage%
    }
  \fi
}
\def\titlepage{%
  \usebeamertemplate{title page}
}

% setion in TOC
\defbeamertemplate{section in toc}{ustutt simple}{
  \leavevmode\leftskip=2.00ex%
  \llap{%
    \usebeamerfont*{section number projected}%
    \usebeamercolor{section number projected}%
    \begin{pgfpicture}{-1.00ex}{0.00ex}{1.00ex}{2.00ex}
      \color{bg}
      \pgfpathcircle{\pgfpoint{0.00pt}{0.75ex}}{1.20ex}
      \pgfusepath{fill}
      \pgftext[base]{\color{fg}\inserttocsectionnumber}
    \end{pgfpicture}\kern1.25ex%
  }%
  \inserttocsection\par%
}

\defbeamertemplate{section in toc}{ustutt bars}{%
  \leavevmode%
  \leftskip=2.00ex%
  \tikzexternaldisable
  \begin{tikzpicture}[%
      baseline={([yshift=-0.80ex]current bounding box.center)},%
    ]%
    \node[%
        anchor=west,%
        align=left,%
        text height=1.50ex,%
        text depth=0.25ex,%
        text width=\linewidth-2.00ex,%
        % text centered,%
        inner sep=0.10ex,%
        outer sep=0.00pt,%
        minimum height=1.50em,%
        rounded corners=0.75em,%
        draw=palette quatenary.bg,%
        fill=palette quatenary.bg,%
      ]%
        (0.00,0.00)%
        {%
          \begin{tikzpicture}[%
              baseline={([yshift=-0.60ex]current bounding box.center)}
            ]%
            \node[%
                circle,%
                text height=1.50ex,%
                text depth=0.25ex,%
                text width=1.50ex,%
                text centered,%
                minimum height=1.50ex,%
                inner sep=0.11ex,%
                align=center,
                % anchor=north,%
                draw=palette primary.fg,%
                fill=palette primary.fg,%
              ]%
                (0.00,0.00)%
                  {
                    \usebeamerfont{section number projected}%
                    \usebeamercolor[bg]{section number projected}%
                    \inserttocsectionnumber%
                  };
          \end{tikzpicture}%
          \hspace*{0.50ex}%
          \usebeamerfont{section in toc}%
          \usebeamercolor{section in toc}%
          \inserttocsection\par%
        };%
  \end{tikzpicture}%
  \tikzexternalenable%
}

% subsection in TOC
\defbeamertemplate*{subsection in toc}{ustutt simple}{%
  \leavevmode%
  \leftskip=2.00em%
  \inserttocsubsection%
  \par%
}
% Subsection in TOC
\defbeamertemplate{subsection in toc}{ustutt bars}{%
  \leavevmode%
  % \smaller[1]
  \leftskip=2.00em%
  \tikzexternaldisable
  \begin{tikzpicture}[%
      baseline={([yshift=-0.80ex]current bounding box.center)},%
    ]%
    \node[%
        anchor=west,%
        align=left,%
        text height=1.50ex,%
        text depth=0.25ex,%
        text width=\linewidth-2.00em,%
        % text centered,%
        inner sep=0.10ex,%
        outer sep=0.00pt,%
        minimum height=1.50em,%
        rounded corners=0.75em,%
        draw=palette quatenary.bg,%
        fill=palette quatenary.bg,%
      ]%
        (0.00,0.00)%
        {%
          \begin{tikzpicture}[%
              baseline={([yshift=-0.60ex]current bounding box.center)}
            ]%
            \node[%
                circle,%
                text height=1.50ex,%
                text depth=0.25ex,%
                text width=1.50ex,%
                text centered,%
                minimum height=1.50ex,%
                inner sep=0.11ex,%
                align=center,
                % anchor=north,%
                draw=palette primary.fg,%
                fill=palette primary.fg,%
              ]%
                (0.00,0.00)%
                  {
                    \usebeamerfont{subsection number projected}%
                    \usebeamercolor[bg]{subsection number projected}%
                    \inserttocsubsectionnumber%
                  };
          \end{tikzpicture}%
          \hspace*{0.50em}%
          \usebeamerfont{subsection in toc}%
          \usebeamercolor{subsection in toc}%
          \inserttocsubsection\par%
        };%
  \end{tikzpicture}\par
  \tikzexternalenable
  % \vspace*{-0.90em}
}

% subsubsection in toc
\defbeamertemplate*{subsubsection in toc}{ustutt simple}{%
  \leavevmode%
  \normalsize%
  \usebeamerfont{subsection in toc}%
  \leftskip=3.00em%
  \usebeamerfont{subsubsection in toc}%
  \inserttocsubsubsection%
  \par%
}

% \setbeamertemplate{title graphic}{
%   \vbox to 0.00pt {
%     \vspace*{2.00em}
%     \inserttitlegraphic%
%   }%
%   \nointerlineskip%
% }

\setbeamertemplate{title}{%
  % \fbox{
  % \begin{minipage}[b]{0.50\paperheight}
    \usebeamercolor[fg]{subtitle}%
    \usebeamerfont{title}%
    \linespread{1.00}%
    \inserttitle%
    \par%
  % \end{minipage}
  % }
  \vspace*{0.50em}%
}

\setbeamertemplate{subtitle}{%
  % \fbox{
  % \begin{minipage}[t]{0.50\paperheight}
    \usebeamercolor[fg]{subtitle}%
    \usebeamerfont{subtitle}%
    \insertsubtitle%
    \par%
  % \end{minipage}
  % }
  % \vspace*{0.50em}%
}

\setbeamertemplate{institute}{%
  \usebeamercolor[fg]{institute}%
  \linespread{1.10}%
  \normalbaselines
  \usebeamerfont{institute}%
  \insertinstitute%
  \par%
}

\newlength{\ustutt@titleseparator@linewidth}
\setlength{\ustutt@titleseparator@linewidth}{0.40pt}
\setbeamertemplate{title separator}{
  \tikzexternaldisable%
  \begin{tikzpicture}
    \fill[fg] (0.00,0.00) rectangle (\textwidth, \ustutt@titleseparator@linewidth);
  \end{tikzpicture}%
  \tikzexternalenable%
  \par%
}
\setbeamertemplate{author}{
  \usebeamercolor{author}%
  \usebeamerfont{author}%
  % \vspace*{2.00em}
  \insertauthor%
  % \par%
  % \vspace*{0.25em}
}
\setbeamertemplate{date}{
  \insertdate%
  \par%
}

% Section page template
\defbeamertemplate*{section page}{ustutt}{%
  \tikzexternaldisable%
  \normalbaselines%
  \setstretch{1.75}%
  \begin{tikzpicture}[
      remember picture,%
      overlay,%
      inner sep=0.00pt,%
      outer sep=0.00pt,%
    ]
    % Background gradient
    \draw[%
        left color=UStuttAccent1,%
        right color=UStuttAccent2,%
        shading=axis,%
        shading angle=270,%
        draw=none,%
      ]%
      (current page.north west)%
        rectangle (current page.south east);%
    % White background circle
    \draw[%
        fill=bg,%
        draw=bg,%
      ]
      (0.45\paperwidth, 0.325\paperheight)%
        circle (0.35\paperwidth);%
    % Current section title
    \node[%
        draw=none,%
        text width=0.475\paperwidth,%
        inner sep=1.00ex,%
        anchor=north west,%
        align=flush left,%
      ]%
        at (0.20\paperwidth,0.20\paperwidth)%
        {%
          \usebeamercolor[fg]{section title}%
          \usebeamerfont{section title}%
          \insertsection%
        };%
  \end{tikzpicture}%
  \tikzexternalenable%
}

% @TODO Line spacing does not seem to work right. Use e.g., `\subsection{And for some reason some even more tremendously long long subsection title}` and look at the result
% Subsection page template
\defbeamertemplate*{subsection page}{ustutt}{%
  \tikzexternaldisable%
  \normalbaselines%
  \setstretch{1.825}%
  \begin{tikzpicture}[
      remember picture,%
      overlay,%
      inner sep=0.00pt,%
      outer sep=0.00pt,%
    ]
    \draw[%
        fill=UStuttDarkOne,%
        draw=UStuttDarkOne,%
      ]%
        (current page.north west)%
          rectangle (current page.south east);
    % Current section title
    \node[%
        anchor=south west,%
        text width=0.625\paperwidth,
        align=flush left,%
      ]%
        at (0.25\paperwidth, 1.00em)%
        {
          \usebeamercolor[fg]{subsection title}%
          \usebeamerfont{subsection title}%
          \insertsection%
        };%
    % Current subsection title
    \node[%
        anchor=north west,%
        text width=0.625\paperwidth,%
        align=flush left,%
      ]%
        at (0.25\paperwidth, 0.00em)%
        {%
          \usebeamercolor[fg]{subsection title}%
          \usebeamerfont{section title}%
          \insertsubsection%
        };%
  \end{tikzpicture}%
  \tikzexternalenable%
}

\newcommand{\ustutt@disablesectionpage}{
  \AtBeginSection[%
    % intentionally empty
  ]{%
    % intentionally empty
  }%
}
\newcommand{\ustutt@enablesectionpage}{
  \AtBeginSection[%
    % intentionally empty
  ]{%
    \ifbeamer@inframe%
      \sectionpage%
    \else%
      \frame[plain,c,noframenumbering]{\sectionpage}%
    \fi%
  }%
}
\newcommand{\ustutt@disablesubsectionpage}{
  \AtBeginSubsection[%
    % intentionally empty
  ]{%
    % intentionally empty
  }%
}
\newcommand{\ustutt@enablesubsectionpage}{
  \AtBeginSubsection[%
    % intentionally empty
  ]{%
    \ifbeamer@inframe%
      \subsectionpage%
    \else%
      \frame[plain,c,noframenumbering]{\subsectionpage}%
    \fi%
  }%
}

% \phone{82448}
\newcommand{\phone}[1]{\gdef\ustutt@author@phone{#1}}
\gdef\ustutt@author@phone{}

% \profilegraphics{path/to/image}
\newcommand{\profilegraphics}[1]{\gdef\ustutt@author@profilegraphics{#1}}
\gdef\ustutt@author@profilegraphics{}

% \telefax{72448}
\newcommand{\telefax}[1]{\gdef\ustutt@author@telefax{#1}}
\gdef\ustutt@author@telefax{}

% \email{philipp.tempel@isw.uni-stuttgart.de}
\newcommand{\email}[1]{\gdef\ustutt@author@email{#1}}
\gdef\ustutt@author@email{}

% \address{Street, Number \and Zip, City \and Country}

% \newlength{\ustutt@progressonsectionpage}
% \newlength{\ustutt@progressonsectionpage@linewidth}
% \setlength{\ustutt@progressonsectionpage@linewidth}{0.40pt}
% \setbeamertemplate{progress bar in section page}{
%   \setlength{\ustutt@progressonsectionpage}{%
%     \textwidth * \ratio{\insertframenumber pt}{\inserttotalframenumber pt}%
%   }%
%   \tikzexternaldisable%
%   \begin{tikzpicture}
%     \fill[bg] (0.00,0.00) rectangle (\textwidth, \ustutt@progressonsectionpage@linewidth);
%     \fill[fg] (0.00,0.00) rectangle (\ustutt@progressonsectionpage, \ustutt@progressonsectionpage@linewidth);
%   \end{tikzpicture}%
%   \tikzexternalenable%
% }
\def\inserttotalframenumber{100}
\newlength{\ustutt@blocksep}
\newlength{\ustutt@blockadjust}
\setlength{\ustutt@blocksep}{0.75ex}
\setlength{\ustutt@blockadjust}{0.25ex}
\providecommand{\ustutt@strut}{%
  \vphantom{ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz()}%
}
\newcommand{\ustutt@block}[1]{
  \par\vskip\medskipamount%
  \setlength{\parskip}{0.00pt}
  \IfStrEq{\insertblocktitle}{}{}{% block title
    \ifbeamercolorempty[bg]{block title#1}{%
      \begin{beamercolorbox}[rightskip=0.00pt plus 4.00em]{block title#1}
    }{%
      \ifbeamercolorempty[bg]{block title}{%
        \begin{beamercolorbox}[rightskip=0.00pt plus 4.00em]{block title#1}%
      }{%
        \begin{beamercolorbox}[
          sep=\dimexpr\ustutt@blocksep-\ustutt@blockadjust\relax,
          leftskip=\ustutt@blockadjust,
          rightskip=\dimexpr\ustutt@blockadjust plus 4.00em\relax
        ]{block title#1}%
      }%
    }%
      \usebeamerfont*{block title#1}%
      \ustutt@strut%
      \insertblocktitle%
      \ustutt@strut%
    \end{beamercolorbox}%
  }%
  \nointerlineskip%
  \ifbeamercolorempty[bg]{block body#1}{%
    \begin{beamercolorbox}[vmode]{block body#1}%
  }{%
    \ifbeamercolorempty[bg]{block body}{%
      \begin{beamercolorbox}[vmode]{block body#1}%
    }{%
      \begin{beamercolorbox}[sep=\ustutt@blocksep, vmode]{block body#1}%
      \vspace{-\ustutt@parskip}
    }%
  }%
  \usebeamerfont{block body#1}%
  \setlength{\parskip}{\ustutt@parskip}%
}
\setbeamertemplate{block begin}{\ustutt@block{}}
\setbeamertemplate{block end}{\end{beamercolorbox}\vspace*{0.20ex}}
\setbeamertemplate{block alerted begin}{\ustutt@block{ alerted}}
\setbeamertemplate{block alerted end}{\end{beamercolorbox}\vspace*{0.20ex}}
\setbeamertemplate{block example begin}{\ustutt@block{ example}}
\setbeamertemplate{block example end}{\end{beamercolorbox}\vspace*{0.20ex}}
\setbeamertemplate{block takeaway begin}{\ustutt@block{ takeaway}}
\setbeamertemplate{block takeaway end}{\end{beamercolorbox}\vspace*{0.20ex}}
% \setbeamertemplate{itemize items}{\textbullet}
\setbeamertemplate{caption label separator}{: }
\setbeamertemplate{caption}[numbered]
\setbeamertemplate{footnote}{%
  \parindent 0.00em\noindent%
  \raggedright
  \usebeamercolor{footnote}\hbox to 0.80em{\hfil\insertfootnotemark}\insertfootnotetext\par%
}
\newlength{\ustutt@parskip}
\setlength{\ustutt@parskip}{0.50em}
\setlength{\parskip}{\ustutt@parskip}
\linespread{1.15}
\define@key{beamerframe}{c}[true]{% centered
  \beamer@frametopskip=0.00pt plus 1fill\relax%
  \beamer@framebottomskip=0.00pt plus 1fill\relax%
  \beamer@frametopskipautobreak=0.00pt plus 0.40\paperheight\relax%
  \beamer@framebottomskipautobreak=0.00pt plus 0.60\paperheight\relax%
  \def\beamer@initfirstlineunskip{}%
}
\providebool{ustutt@standout}
\define@key{beamerframe}{standout}[true]{%
  \booltrue{ustutt@standout}%
  \begingroup%
    \setkeys{beamerframe}{c}%
    \setkeys{beamerframe}{noframenumbering}%
    \setkeys{beamerframe}{plain}%
    \ifbeamercolorempty[bg]{palette primary}{%
      \setbeamercolor{background canvas}{%
        use=palette primary,%
        fg=palette primary.fg,%
        bg=palette primary.bg,%
      }%
    }{%
      \setbeamercolor{background canvas}{%
        use=palette primary,%
        fg=palette primary.fg,%
        bg=palette primary.bg,%
      }%
    }%
    \setbeamercolor{local structure}{%
      use=palette primary,%
      fg=palette primary.fg,%
      bg=palette primary.bg,%
    }%
    \setbeamertemplate{frametitle}{}%
    \centering%
    \usebeamercolor[fg]{palette primary}%
    \usebeamerfont{standout}%
}
\apptocmd{\beamer@reseteecodes}{%
  \ifbool{ustutt@standout}{%
    \endgroup%
    \boolfalse{ustutt@standout}%
  }{}%
}{}{}%

% Page layout of quote
\providebool{ustutt@quote}
\define@key{beamerframe}{quote}[true]{%
  \booltrue{ustutt@quote}
  \begingroup
    \usebeamertemplate{quote}[ustutt]
    \setkeys{beamerframe}{c}
    \setkeys{beamerframe}{noframenumbering}
    \ifbeamercolorempty[bg]{palette primary}{
      \setbeamercolor{background canvas}{
        use=palette primary,
        bg=-palette primary.fg
      }
    }{
      \setbeamercolor{background canvas}{
        use=palette primary,%
        bg=palette primary.bg,%
      }
    }
    \setbeamercolor{local structure}{
      fg=palette primary.fg,%
    }
    \centering
    \usebeamercolor[fg]{palette primary}
    \usebeamerfont{quote}
}

\newenvironment<>{takeawayblock}[1]{%
  \vfill % Push block to the bottom

  \begin{actionenv}{}%#2%
    \def\insertblocktitle{#1}%
    % \par%
    \usebeamertemplate{block takeaway begin}%
}{%
  \par%
  \usebeamertemplate{block takeaway end}%
  \end{actionenv}%
}

\apptocmd{\beamer@reseteecodes}{%
  \ifbool{ustutt@quote}{
    \endgroup
    \boolfalse{ustutt@quote}
  }{}
}{}{}

% Page layout of closing frame
\providebool{ustutt@closing}
\define@key{beamerframe}{closing}[true]{%
  \booltrue{ustutt@closing}
  \begingroup
    \setkeys{beamerframe}{c}
    \setkeys{beamerframe}{plain}
    \setkeys{beamerframe}{noframenumbering}
    \ifbeamercolorempty[bg]{palette primary}{
      \setbeamercolor{background canvas}{
        use=palette primary,
        bg=-palette primary.fg
      }
    }{
      \setbeamercolor{background canvas}{
        use=palette primary,%
        bg=palette primary.bg,%
      }
    }
    \setbeamercolor{local structure}{
      fg=palette primary.fg,%
    }
    \centering
    \usebeamercolor[fg]{palette primary}
    \usebeamerfont{standout}
}

\apptocmd{\beamer@reseteecodes}{%
  \ifbool{ustutt@closing}{
    \endgroup
    \boolfalse{ustutt@closing}
  }{}
}{}{}

\ustutt@inner@setdefaults

\ProcessPgfPackageOptions{/ustutt/inner}

\endinput
